﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;


namespace Padaszok_
{
    /// <summary>
    /// A mappák és fileok tárolása
    /// </summary>
    public class FaElem
    {
        /// <summary>
        /// Saját név adatai
        /// </summary>
        public FileElem Nev { get; set; }
        /// <summary>
        /// Mappák esetén gyerekek
        /// </summary>
        public List<FaElem> Gyerekek { get; set; }

        /// <summary>
        /// Konstruktor névből
        /// </summary>
        /// <param name="f">Náv adatai</param>
        public FaElem(FileElem f)
        {
            this.Nev = f;
            this.Gyerekek = new List<FaElem>(); 
        }
        /// <summary>
        /// TreeView-ban használható TreeNode előállítása
        /// </summary>
        /// <returns>A saját magát, és almappáit jellemző TreeNode</returns>
        public TreeNode Fava()
        {
            TreeNode en = new TreeNode();
            en.Text = Nev.FileNev;
            foreach(FaElem elem in Gyerekek) {
                en.Nodes.Add(elem.Fava());
            }
            return en;
        }
    }
}
