﻿#define PAST_IS_BUG

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.IO;

namespace Padaszok_
{
    public partial class Form1 : Form
    {
        public int Allapotszam = 0;
        public List<FaElem> Allapotok;
        public FaHasonlit Hasonlito;

        /// <summary>
        /// Betölti a filerendszer mentéseket egy mappából
        /// </summary>
        /// <param name="mappa">A mappa elérési útja</param>
        public void FilerendszerBetolt(String mappa)
        {   
            while(File.Exists(mappa+"/filerendszer-" + Convert.ToString(Allapotszam) + ".txt")) {
                String[] data = File.ReadAllLines(mappa + "/filerendszer-" + Convert.ToString(Allapotszam) + ".txt");
                FaEpit fa = new FaEpit();
                FaElem uj = fa.Epit(data);
                Allapotok.Add(uj);
                Allapotszam += 1;
            }
            Allapotvalaszto1.Maximum = Allapotszam - 1;
            Allapotvalaszto2.Maximum = Allapotszam - 1;
        }

        /// <summary>
        /// Elkészíti a fő ablakot
        /// </summary>
        public Form1()
        {
            Hasonlito = new FaHasonlit();
            Allapotok = new List<FaElem>();
            InitializeComponent();
        }

        /// <summary>
        /// A formon kiválasztott állapot szerint beállítja 
        /// a változáslistát és a fájlistát
        /// </summary>
        public void AllapotKivalaszt()
        {
            int allregi = Allapotvalaszto1.Value;
            int alluj = Allapotvalaszto2.Value;


            Allapot1.Text = Convert.ToString(allregi);
            Allapot2.Text = Convert.ToString(alluj);
            Valtozas.Items.Clear();

            //FaHasonlito.Hasonlit(Allapotok[Allapotvalaszto.Value - 1], Allapotok[Allapotvalaszto.Value]);
            List<FaHasonlit.KulElem> kul = Hasonlito.Hasonlit(Allapotok[Allapotvalaszto1.Value], Allapotok[Allapotvalaszto2.Value]);
            foreach (FaHasonlit.KulElem elem in kul)
            {
                if (elem.UjFile.SpecialisE()) continue;
                if (elem.Kul == FaHasonlit.Kulonbseg.UGYAN) continue;
                Valtozas.Items.Add(elem.ToString());
            }
            /*
            Fajlrendszer.Nodes.Clear();
            TreeNode root = Allapotok[alluj].Fava();
            foreach (TreeNode node in root.Nodes)
            {
                Fajlrendszer.Nodes.Add(node);
            }*/

            FajlrendszerEpit(kul);
        }
        
        /// <summary>
        /// Felépíti a filerendszer fáját a megadott változások alapján
        /// </summary>
        /// <param name="lista">A változások listája</param>
        public void FajlrendszerEpit(List<FaHasonlit.KulElem> lista)
        {

            Fajlrendszer.Nodes.Clear();

            FileElem gyokerFile = new FileElem("/ 0 0");
            FaElem gyokerElem = new FaElem(gyokerFile);
            TreeNode gyokerT = new TreeNode();

            foreach (var sor in lista)
            {
                FileElem fi = sor.UjFile;
                FaElem pill = gyokerElem;
                TreeNode pillT = gyokerT;

                for (int i = 1; i < fi.Konyvtar.Length - 1; ++i)
                {
                    for (int j = 0; j < pill.Gyerekek.Count; ++j)
                    {
                        FileElem pillKonyvtar = pill.Gyerekek[j].Nev;

                        if (fi.Konyvtar[i] == pillKonyvtar.Konyvtar[pillKonyvtar.Konyvtar.Length - 2])
                        {
                            pill = pill.Gyerekek[j];
                            pillT = pillT.Nodes[j];
                            break;
                        }
                    }
                }

                pill.Gyerekek.Add(new FaElem(fi));
                TreeNode nf = new TreeNode();
                nf.Text = fi.FileNev;
                switch (sor.Kul)
                {
                    case FaHasonlit.Kulonbseg.UGYAN:
                        nf.ForeColor = Color.Black;
                        nf.BackColor = Color.White;
                        break;
                    case FaHasonlit.Kulonbseg.LETR:
                        nf.ForeColor = Color.Black;
                        nf.BackColor = Color.LightGreen;
                        break;
                    case FaHasonlit.Kulonbseg.MOD:
                        nf.ForeColor = Color.Black;
                        nf.BackColor = Color.Wheat;
                        break;
                    case FaHasonlit.Kulonbseg.TOROL:
                        nf.ForeColor = Color.White;
                        nf.BackColor = Color.DarkRed;
                        break;
                    case FaHasonlit.Kulonbseg.RTOROL:
                        nf.ForeColor = Color.White;
                        nf.BackColor = Color.Black;
                        break;
                }
                if (sor.UjFile.SpecialisE())
                {
                    if (nf.ForeColor == Color.White)
                        nf.ForeColor = Color.FromArgb(255, 150, 150, 150);
                    if (nf.ForeColor == Color.Black)
                        nf.ForeColor = Color.Gray;
                }
                nf.Expand();
                pillT.Nodes.Add(nf);
            }

            foreach (TreeNode node in gyokerT.Nodes)
            {
                Fajlrendszer.Nodes.Add(node);
            }
        } //*/

        /// <summary>
        /// Frissíti az állapotot
        /// </summary>
        private void trackBar1_Scroll(object sender, EventArgs e)
        {
#if PAST_IS_BUG
            if (Allapotvalaszto1.Value > Allapotvalaszto2.Value)
            {
                if(sender == Allapotvalaszto1)
                    Allapotvalaszto2.Value = Allapotvalaszto1.Value;
                else
                    Allapotvalaszto1.Value = Allapotvalaszto2.Value;
            } //*/
#endif
            AllapotKivalaszt();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            folderBrowserDialog1.ShowDialog();
            FilerendszerBetolt(folderBrowserDialog1.SelectedPath);
            AllapotKivalaszt();
            this.Show();
            this.Activate();
        }

        private void folderBrowserDialog1_HelpRequest(object sender, EventArgs e)
        {

        }
    }
}
